// Code generated - DO NOT EDIT.
// This file is a generated binding and any manual changes will be lost.

package feedback

import (
	"errors"
	"math/big"
	"strings"

	ethereum "github.com/ethereum/go-ethereum"
	"github.com/ethereum/go-ethereum/accounts/abi"
	"github.com/ethereum/go-ethereum/accounts/abi/bind"
	"github.com/ethereum/go-ethereum/common"
	"github.com/ethereum/go-ethereum/core/types"
	"github.com/ethereum/go-ethereum/event"
)

// Reference imports to suppress errors if they are not otherwise used.
var (
	_ = errors.New
	_ = big.NewInt
	_ = strings.NewReader
	_ = ethereum.NotFound
	_ = bind.Bind
	_ = common.Big1
	_ = types.BloomLookup
	_ = event.NewSubscription
	_ = abi.ConvertType
)

// FeedbackMetaData contains all meta data concerning the Feedback contract.
var FeedbackMetaData = &bind.MetaData{
	ABI: "[{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"name\":\"feedbackList\",\"outputs\":[{\"internalType\":\"string\",\"name\":\"\",\"type\":\"string\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"index\",\"type\":\"uint256\"}],\"name\":\"getFeedback\",\"outputs\":[{\"internalType\":\"string\",\"name\":\"\",\"type\":\"string\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"feedback\",\"type\":\"string\"}],\"name\":\"submitFeedback\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"}]",
}

// FeedbackABI is the input ABI used to generate the binding from.
// Deprecated: Use FeedbackMetaData.ABI instead.
var FeedbackABI = FeedbackMetaData.ABI

// Feedback is an auto generated Go binding around an Ethereum contract.
type Feedback struct {
	FeedbackCaller     // Read-only binding to the contract
	FeedbackTransactor // Write-only binding to the contract
	FeedbackFilterer   // Log filterer for contract events
}

// FeedbackCaller is an auto generated read-only Go binding around an Ethereum contract.
type FeedbackCaller struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// FeedbackTransactor is an auto generated write-only Go binding around an Ethereum contract.
type FeedbackTransactor struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// FeedbackFilterer is an auto generated log filtering Go binding around an Ethereum contract events.
type FeedbackFilterer struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// FeedbackSession is an auto generated Go binding around an Ethereum contract,
// with pre-set call and transact options.
type FeedbackSession struct {
	Contract     *Feedback         // Generic contract binding to set the session for
	CallOpts     bind.CallOpts     // Call options to use throughout this session
	TransactOpts bind.TransactOpts // Transaction auth options to use throughout this session
}

// FeedbackCallerSession is an auto generated read-only Go binding around an Ethereum contract,
// with pre-set call options.
type FeedbackCallerSession struct {
	Contract *FeedbackCaller // Generic contract caller binding to set the session for
	CallOpts bind.CallOpts   // Call options to use throughout this session
}

// FeedbackTransactorSession is an auto generated write-only Go binding around an Ethereum contract,
// with pre-set transact options.
type FeedbackTransactorSession struct {
	Contract     *FeedbackTransactor // Generic contract transactor binding to set the session for
	TransactOpts bind.TransactOpts   // Transaction auth options to use throughout this session
}

// FeedbackRaw is an auto generated low-level Go binding around an Ethereum contract.
type FeedbackRaw struct {
	Contract *Feedback // Generic contract binding to access the raw methods on
}

// FeedbackCallerRaw is an auto generated low-level read-only Go binding around an Ethereum contract.
type FeedbackCallerRaw struct {
	Contract *FeedbackCaller // Generic read-only contract binding to access the raw methods on
}

// FeedbackTransactorRaw is an auto generated low-level write-only Go binding around an Ethereum contract.
type FeedbackTransactorRaw struct {
	Contract *FeedbackTransactor // Generic write-only contract binding to access the raw methods on
}

// NewFeedback creates a new instance of Feedback, bound to a specific deployed contract.
func NewFeedback(address common.Address, backend bind.ContractBackend) (*Feedback, error) {
	contract, err := bindFeedback(address, backend, backend, backend)
	if err != nil {
		return nil, err
	}
	return &Feedback{FeedbackCaller: FeedbackCaller{contract: contract}, FeedbackTransactor: FeedbackTransactor{contract: contract}, FeedbackFilterer: FeedbackFilterer{contract: contract}}, nil
}

// NewFeedbackCaller creates a new read-only instance of Feedback, bound to a specific deployed contract.
func NewFeedbackCaller(address common.Address, caller bind.ContractCaller) (*FeedbackCaller, error) {
	contract, err := bindFeedback(address, caller, nil, nil)
	if err != nil {
		return nil, err
	}
	return &FeedbackCaller{contract: contract}, nil
}

// NewFeedbackTransactor creates a new write-only instance of Feedback, bound to a specific deployed contract.
func NewFeedbackTransactor(address common.Address, transactor bind.ContractTransactor) (*FeedbackTransactor, error) {
	contract, err := bindFeedback(address, nil, transactor, nil)
	if err != nil {
		return nil, err
	}
	return &FeedbackTransactor{contract: contract}, nil
}

// NewFeedbackFilterer creates a new log filterer instance of Feedback, bound to a specific deployed contract.
func NewFeedbackFilterer(address common.Address, filterer bind.ContractFilterer) (*FeedbackFilterer, error) {
	contract, err := bindFeedback(address, nil, nil, filterer)
	if err != nil {
		return nil, err
	}
	return &FeedbackFilterer{contract: contract}, nil
}

// bindFeedback binds a generic wrapper to an already deployed contract.
func bindFeedback(address common.Address, caller bind.ContractCaller, transactor bind.ContractTransactor, filterer bind.ContractFilterer) (*bind.BoundContract, error) {
	parsed, err := FeedbackMetaData.GetAbi()
	if err != nil {
		return nil, err
	}
	return bind.NewBoundContract(address, *parsed, caller, transactor, filterer), nil
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_Feedback *FeedbackRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _Feedback.Contract.FeedbackCaller.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_Feedback *FeedbackRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _Feedback.Contract.FeedbackTransactor.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_Feedback *FeedbackRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _Feedback.Contract.FeedbackTransactor.contract.Transact(opts, method, params...)
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_Feedback *FeedbackCallerRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _Feedback.Contract.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_Feedback *FeedbackTransactorRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _Feedback.Contract.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_Feedback *FeedbackTransactorRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _Feedback.Contract.contract.Transact(opts, method, params...)
}

// FeedbackList is a free data retrieval call binding the contract method 0x5d837247.
//
// Solidity: function feedbackList(uint256 ) view returns(string)
func (_Feedback *FeedbackCaller) FeedbackList(opts *bind.CallOpts, arg0 *big.Int) (string, error) {
	var out []interface{}
	err := _Feedback.contract.Call(opts, &out, "feedbackList", arg0)

	if err != nil {
		return *new(string), err
	}

	out0 := *abi.ConvertType(out[0], new(string)).(*string)

	return out0, err

}

// FeedbackList is a free data retrieval call binding the contract method 0x5d837247.
//
// Solidity: function feedbackList(uint256 ) view returns(string)
func (_Feedback *FeedbackSession) FeedbackList(arg0 *big.Int) (string, error) {
	return _Feedback.Contract.FeedbackList(&_Feedback.CallOpts, arg0)
}

// FeedbackList is a free data retrieval call binding the contract method 0x5d837247.
//
// Solidity: function feedbackList(uint256 ) view returns(string)
func (_Feedback *FeedbackCallerSession) FeedbackList(arg0 *big.Int) (string, error) {
	return _Feedback.Contract.FeedbackList(&_Feedback.CallOpts, arg0)
}

// GetFeedback is a free data retrieval call binding the contract method 0x1106a382.
//
// Solidity: function getFeedback(uint256 index) view returns(string)
func (_Feedback *FeedbackCaller) GetFeedback(opts *bind.CallOpts, index *big.Int) (string, error) {
	var out []interface{}
	err := _Feedback.contract.Call(opts, &out, "getFeedback", index)

	if err != nil {
		return *new(string), err
	}

	out0 := *abi.ConvertType(out[0], new(string)).(*string)

	return out0, err

}

// GetFeedback is a free data retrieval call binding the contract method 0x1106a382.
//
// Solidity: function getFeedback(uint256 index) view returns(string)
func (_Feedback *FeedbackSession) GetFeedback(index *big.Int) (string, error) {
	return _Feedback.Contract.GetFeedback(&_Feedback.CallOpts, index)
}

// GetFeedback is a free data retrieval call binding the contract method 0x1106a382.
//
// Solidity: function getFeedback(uint256 index) view returns(string)
func (_Feedback *FeedbackCallerSession) GetFeedback(index *big.Int) (string, error) {
	return _Feedback.Contract.GetFeedback(&_Feedback.CallOpts, index)
}

// SubmitFeedback is a paid mutator transaction binding the contract method 0xe341a623.
//
// Solidity: function submitFeedback(string feedback) returns()
func (_Feedback *FeedbackTransactor) SubmitFeedback(opts *bind.TransactOpts, feedback string) (*types.Transaction, error) {
	return _Feedback.contract.Transact(opts, "submitFeedback", feedback)
}

// SubmitFeedback is a paid mutator transaction binding the contract method 0xe341a623.
//
// Solidity: function submitFeedback(string feedback) returns()
func (_Feedback *FeedbackSession) SubmitFeedback(feedback string) (*types.Transaction, error) {
	return _Feedback.Contract.SubmitFeedback(&_Feedback.TransactOpts, feedback)
}

// SubmitFeedback is a paid mutator transaction binding the contract method 0xe341a623.
//
// Solidity: function submitFeedback(string feedback) returns()
func (_Feedback *FeedbackTransactorSession) SubmitFeedback(feedback string) (*types.Transaction, error) {
	return _Feedback.Contract.SubmitFeedback(&_Feedback.TransactOpts, feedback)
}
